﻿using BaseApplicationProject.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;
using Telerik.Windows.DragDrop;

namespace BaseApplicationProject
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DragDropManager.AddDragOverHandler(this.treeB, OnDragOverBTree, true);
            DragDropManager.AddDragDropCompletedHandler(this.treeA, OnDropComplete, true);

            this.treeA.IsDragDropEnabled = true;
            this.treeB.IsDragDropEnabled = true;           
        }


        private void OnDropComplete(object sender, DragDropCompletedEventArgs e)
        {
            var options = DragDropPayloadManager.GetDataFromObject(e.Data, TreeViewDragDropOptions.Key) as TreeViewDragDropOptions;
            if (options != null && options.DropAction == DropAction.Copy)
            {
                DataItem sourceItem = options.DraggedItems.FirstOrDefault() as DataItem;
                if (sourceItem == null) return;

                DataItem copy = new DataItem()
                {
                    Title = sourceItem.Title
                };
                options.SetDraggedItems(new List<DataItem>() { copy });
            }
        }

        private void OnDragOverBTree(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
        {
            var options = DragDropPayloadManager.GetDataFromObject(e.Data, TreeViewDragDropOptions.Key) as TreeViewDragDropOptions;
            if (options != null)
            {
                options.DropAction = DropAction.Copy;
            }
        }
    }
}
